ShinyEnv:Use("ShinyStats")

-- The following stuff is unfortunately necessary, because some addons *override*
-- the tooltip handlers instead of hooking them :(


local f = CreateFrame("Frame")
local entered = false

ShinyStats.listener = f
f:SetScript("OnEvent", function(f, e, ...) f[e](f, ...) end)


function f:PLAYER_ENTERING_WORLD()
	entered = true

	f:ScheduleHook()
end


function f:ADDON_LOADED()
	if entered then
		f:ScheduleHook()
	end
end


function f:PLAYER_SPECIALIZATION_CHANGED(frame, ...)
	ShinyStats:UpdateSpec()
end


function f:PLAYER_TALENT_UPDATE(frame, ...)
	ShinyStats:UpdateSpec()
end


function f:ScheduleHook()
	C_Timer.After(3, f.OnTimer)
end


function f:OnTimer()
	f:UnregisterEvent("PLAYER_ENTERING_WORLD")
	f:UnregisterEvent("ADDON_LOADED")

	ShinyStats:HookTooltips()
	ShinyStats:HookEvents()
	ShinyStats:UpdateSpec()
end

f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:RegisterEvent("ADDON_LOADED")
