ShinyEnv:Use("ShinyStats")

ShinyDB = {}

function ShinyDB:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("ShinyStatsDB", 
    	{
			profile = {
				colors = (function() 
					local colors = {}

					for k,v in pairs(DEFAULT_COLORS) do
						if (k ~= SHINY_PASSTHRU and v) then
							colors[k] = {
								id = k,
								enabled = v ~= false,
								value = v,
							}
						end
					end

					return colors
				end)(),
				options = DEFAULT_OPTIONS,
			},
		}, true)

	self.db.RegisterCallback(ShinyStats, "OnProfileChanged", "ReloadConfig")
	self.db.RegisterCallback(ShinyStats, "OnProfileCopied", "ReloadConfig")
	self.db.RegisterCallback(ShinyStats, "OnProfileReset", "ReloadConfig")
end


function ShinyDB:GetOption(k)
	return self.db.profile.options[k]
end


function ShinyDB:SetOption(k,v)
	self.db.profile.options[k] = v
end


function ShinyDB:GetColor(k)
	return self.db.profile.colors[k]
end


function ShinyDB:SetColor(k,v)
	self.db.profile.colors[k] = v
end


function ShinyDB:GetActive()
	return self.db.profile
end


function ShinyDB:GetDB()
	return self.db
end
