ShinyEnv:Use("ShinyStats")

Pattern = {}
Pattern.__index = Pattern


local bor, 	   band =
	  bit.bor, bit.band
	  

function Pattern:New(pattern, colorID, ...)
	local instance = {
		pattern = pattern,
		colorID = colorID,
		categories = bor(...) or 0, 
		enabled = true,
	}

	self.__index = self
	return setmetatable(instance, self)
end


function Pattern:Unpack()
	return self.pattern, self.colorID, self.cateogires, self.enabled
end


function Pattern:Enable()
	self.enabled = true
end


function Pattern:Disable()
	self.enabled = false
end


function Pattern:IsEnabled()
	return self.enabled
end


function Pattern:SetEnabled(bool)
	self.enabled = bool
end


function Pattern:HasAnyOf(...)
	return bit.hasAnyOf(self.categories, ...)
end


function Pattern:HasAllOf(...)
	return bit.hasAllOf(self.categories, ...)
end


function Pattern:HasAllOf(...)
	return bit.hasAllOf(self.categories, ...)
end


Pattern.HasCategory = Pattern.HasAllOf

function CreatePattern(...)
	return Pattern:New(...)
end
