ShinyEnv:Use("ShinyStats")


local L = ShinyLocale


EQUIP_PROC_TRANSFORMATION_MAP = {
	[L["^Equip: Your damaging spells have a chance to (.+)"]]                      = L["Chance on: Damaging Spells"],
	[L["^Equip: Your damaging spells have a chance for (.+)"]]                     = L["Chance on: Damaging Spells"],
	[L["^Equip: Your damaging spellcasts have a chance to (.+)"]]                  = L["Chance on: Damaging Spellcasts"],
	[L["^Equip: Your damaging spells and abilities have a chance to (.+)"]]        = L["Chance on: Damaging Spells, Abilities"],

	[L["^Equip: Your healing spells have a chance to (.+)"]]                       = L["Chance on: Healing Spells"],
	[L["^Equip: Your healing spellcasts have a chance to (.+)"]]                   = L["Chance on: Healing Spellcasts"],
	[L["^Equip: Your healing spells and abilities have a chance to (.+)"]]         = L["Chance on: Healing Spells, Abilities"],
	[L["^Equip: Your healing effects have a chance to (.+)"]]                      = L["Chance on: Healing Effects"],
	[L["^Equip: When you heal you have a chance to (.+)"]]                         = L["Chance on: Healing"],

	[L["^Equip: Your spells and abilities have a chance to (.+)"]]			       = L["Chance on: Spells, Abilities"],
	[L["^Equip: Your spells have a chance to (.+)"]]                     		   = L["Chance on: Spells"],
	[L["^Equip: When you deal damage or heal a target you have a chance to (.+)"]] = L["Chance on: Dealing Damage, Healing"],
	[L["^Equip: When you heal or deal damage you have a chance to (.+)"]]          = L["Chance on: Dealing Damage, Healing"],
	[L["^Equip: Your ranged attacks and spells have a chance to (.+)"]]            = L["Chance on: Ranged, Spells"],

	[L["^Equip: Your ranged attacks have a chance to (.+)"]]                       = L["Chance on: Ranged"],
	[L["^Equip: Your melee attacks have a chance to (.+)"]]                        = L["Chance on: Melee"],
	[L["^Equip: Your critical autoattacks have a chance to (.+)"]]                 = L["Chance on: Critical Auto-Attacks"],
	[L["^Equip: When your attacks hit you have a chance to (.+)"]]                 = L["Chance on: Hit Attacks"],
	[L["^Equip: Your ranged and melee attacks have a chance to (.+)"]]             = L["Chance on: Melee, Ranged"],
	[L["^Equip: Your attacks have a chance to (.+)"]]                              = L["Chance on: Attacks"],

	[L["^Equip: When you deal damage you have a chance to (.+)"]]                  = L["Chance on: Dealing Damage"],
	[L["^Equip: Taking damage has a chance to (.+)"]]                              = L["Chance on: Taking Damage"],
	[L["^Equip: Chance on being hit to (.+)"]]			                           = L["Chance on: Being Hit"],
}


EQUIP_EFFECT_TRANSFORMATION_MAP = {
	[L["^Equip: Your melee auto attacks (.+)"]]                      			   = L["Effect on: Melee Auto-Attacks"],
}


-- USE_TRANSFORMATION_MAP = {
-- 	[L["^Use: Restores ({STAT_NUMBER} [Hh]ealth) and ({STAT_NUMBER} [Mm]ana)"]]  = L["Chance on: Damaging Spells"],
-- 	[L["^Use: Your damaging spells have a chance for (.+)"]]                     = L["Chance on: Damaging Spells"],
-- 	[L["^Use: Your damaging spellcasts have a chance to (.+)"]]                  = L["Chance on: Damaging Spellcasts"],
-- 	[L["^Use: Your damaging spells and abilities have a chance to (.+)"]]        = L["Chance on: Damaging Spells, Abilities"],
-- }


-- USE_TRANSFORMATION_PATTERNS = {
-- 	[L["^[Rr]estores ({STAT_NUMBER}) [Hh]ealth and ({STAT_NUMBER}) [Mm]ana over 20 sec"]] = L["Restores %1 health (over 20 sec)\nRestores %2 mana (over 20 sec)"],
	
-- 	[L["^[Rr]estores ({STAT_NUMBER}) [Hh]ealth over 20 sec"]] = L["Restores %1 health (over 20 sec)"],
-- 	[L["^[Rr]estores ({STAT_NUMBER}) [Mm]ana over 20 sec"]] = L["Restores %1 mana (over 20 sec)"],

-- 	[L["^[Rr]estores ({STAT_NUMBER}) [Hh]ealth."]] = L["Restores %1 health (instant)"],
-- 	[L["^[Rr]estores ({STAT_NUMBER}) to ({STAT_NUMBER}) [Hh]ealth."]] = L["Restores %1 health (instant)"],
-- 	[L["^[Rr]estores ({STAT_NUMBER}) [Mm]ana."]] = L["Restores %1 mana (instant)"],


-- 	[L["%(([%d.,]+ %a-) [Cc]ooldown%)"]] = L["Cooldown: %1"],
-- 	[L["If you spend at least 10 seconds eating you will become well fed and (.+)"]] = "WELL_FED",
-- }


-- USE_TRANSFORM_MATCH_PATTERNS = {
-- 	{ 	
-- 		criteria = {	
-- 			L["^Use: Restores .- over 20 sec"]
-- 		},
-- 		replacements = {
-- 			[L["({STAT_NUMBER}) [Hh]ealth"]] 					= L["%1 health (over 20 sec)"],
-- 			[L["({STAT_NUMBER}) to ({STAT_NUMBER}) [Hh]ealth"]] = L["%1 - %2 health (over 20 sec)"],
-- 			[L["({STAT_NUMBER}) [Mm]ana"]]   					= L["%1 mana (over 20 sec)"],
-- 			[L["({STAT_NUMBER}) to ({STAT_NUMBER}) [Mm]ana"]]   = L["%1 - %2 mana (over 20 sec)"],
-- 		},
-- 	},
-- 	{ 	
-- 		criteria = {	
-- 			L["^Use: Restores .- [Cc]ooldown"], 
-- 			L["^Use: Instantly restores .- [Cc]ooldown"],
-- 		},
-- 		replacements = {
-- 			[L["({STAT_NUMBER}) [Hh]ealth"]] 					= L["%1 health (instant)"],
-- 			[L["({STAT_NUMBER}) to ({STAT_NUMBER}) [Hh]ealth"]] = L["%1 - %2 health (instant)"],
-- 			[L["({STAT_NUMBER}) [Mm]ana"]]   					= L["%1 mana (instant)"],
-- 			[L["({STAT_NUMBER}) to ({STAT_NUMBER}) [Mm]ana"]]   = L["%1 - %2 mana (instant)"],
-- 		},
-- 		title = {
-- 			[L["%(([%d.,]+ %a-) [Cc]ooldown%)"]] 				= "Use ("..L["Cooldown: %1"],
-- 		}
-- 	},
-- }


PATTERN_MAP = {

--[[  S  T  A  N  D  A  R  D  ]]--
	CreatePattern(L["{STAT_NUMBER} [Aa]gility"],			                            SHINY_AGILITY,                 PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_MULTIPLE),
	CreatePattern(L["Agility by {STAT_NUMBER}"],			                            SHINY_AGILITY,                 PATTERN_CATEGORY_PARTIAL),
	
	CreatePattern(L["{STAT_NUMBER} [Ss]tamina"],			                            SHINY_STAMINA,                 PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_MULTIPLE),
	CreatePattern(L["Stamina by {STAT_NUMBER}"],			                            SHINY_STAMINA,                 PATTERN_CATEGORY_PARTIAL),

	CreatePattern(L["{STAT_NUMBER} [Ii]ntellect"],			                            SHINY_INTELLECT,               PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_MULTIPLE),
	CreatePattern(L["Intellect by {STAT_NUMBER}"],			                            SHINY_INTELLECT,               PATTERN_CATEGORY_PARTIAL),
	
	CreatePattern(L["{STAT_NUMBER} [Ss]trength"],			                            SHINY_STRENGTH,                PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_MULTIPLE),
	CreatePattern(L["Strength by {STAT_NUMBER}"],			                            SHINY_STRENGTH,                PATTERN_CATEGORY_PARTIAL),
	
	CreatePattern(L["{STAT_NUMBER} [Vv]ersatility"],			                        SHINY_VERSATILITY,             PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_MULTIPLE),
	CreatePattern(L["[Vv]ersatility by {STAT_NUMBER}"],			                        SHINY_VERSATILITY,             PATTERN_CATEGORY_PARTIAL),
		
	CreatePattern(L["{STAT_NUMBER} [Mm]astery"],			                            SHINY_MASTERY,                 PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_MULTIPLE),
	CreatePattern(L["[Mm]astery by {STAT_NUMBER}"],			                            SHINY_MASTERY,                 PATTERN_CATEGORY_PARTIAL),

	CreatePattern(L["{STAT_NUMBER} [Aa]voidance"],			                            SHINY_AVOIDANCE,               PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_MULTIPLE),
	CreatePattern(L["[Aa]voidance by {STAT_NUMBER}"],			                        SHINY_AVOIDANCE,               PATTERN_CATEGORY_PARTIAL),
	
	CreatePattern(L["{STAT_NUMBER} [Ll]eech"],			                                SHINY_LEECH,                   PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_MULTIPLE),
	CreatePattern(L["[Ll]eech by {STAT_NUMBER}"],			                            SHINY_LEECH,                   PATTERN_CATEGORY_PARTIAL),

	CreatePattern(L["{STAT_NUMBER} [Ss]peed"],			                                SHINY_SPEED,                   PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_MULTIPLE),
	CreatePattern(L["[Ss]peed by {STAT_NUMBER}"],			                            SHINY_SPEED,                   PATTERN_CATEGORY_PARTIAL),

	CreatePattern(L["Indestructible"],			                                        SHINY_INDESTRUCTIBLE,          PATTERN_CATEGORY_LINE),

	CreatePattern(L["{STAT_NUMBER} [Hh]aste"],			                            	SHINY_HASTE,                   PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_MULTIPLE),
	CreatePattern(L["[Hh]aste by {STAT_NUMBER}"],			                            SHINY_HASTE,                   PATTERN_CATEGORY_PARTIAL),
									
	CreatePattern(L["{STAT_NUMBER} [Cc]ritical [Ss]trike"],			                    SHINY_CRITICAL,                PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_MULTIPLE),
	CreatePattern(L["[Cc]ritical [Ss]trike by {STAT_NUMBER}"],			                SHINY_CRITICAL,                PATTERN_CATEGORY_PARTIAL),
					
	CreatePattern(L["{STAT_NUMBER} [Aa]rmor"],			                                SHINY_ARMOR,                   PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL),
	CreatePattern(L["[Aa]rmor by {STAT_NUMBER}"],			                            SHINY_ARMOR,                   PATTERN_CATEGORY_EQUIP, PATTERN_CATEGORY_PARTIAL),
	CreatePattern(L["[Aa]rmor increased by {STAT_NUMBER}"],			                    SHINY_ARMOR,                   PATTERN_CATEGORY_EQUIP, PATTERN_CATEGORY_PARTIAL),

	CreatePattern(L["{STAT_NUMBER} [Pp]v[Pp] [Pp]ower"],			                    SHINY_PVPPOWER,                PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_MULTIPLE),
	CreatePattern(L["[Pp]v[Pp] [Pp]ower by {STAT_NUMBER}"],			                    SHINY_PVPRESILIENCE,           PATTERN_CATEGORY_PARTIAL),

	CreatePattern(L["{STAT_NUMBER} [Pp]v[Pp] [Rr]esilience"],			                SHINY_PVPRESILIENCE,           PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_MULTIPLE),
	CreatePattern(L["[Pp]v[Pp] [Rr]esilience by {STAT_NUMBER}"],			            SHINY_PVPRESILIENCE,           PATTERN_CATEGORY_PARTIAL),

	CreatePattern(L["[Pp]rimary [Ss]tat by {STAT_NUMBER}"],			                    SHINY_PRIMARYSTAT,             PATTERN_CATEGORY_PARTIAL),
	CreatePattern(L["{STAT_NUMBER} in a stat"],			                  			    SHINY_PRIMARYSTAT,             PATTERN_CATEGORY_PARTIAL),
	CreatePattern(L["{STAT_NUMBER} in a useful stat"],			                  	    SHINY_PRIMARYSTAT,             PATTERN_CATEGORY_PARTIAL),

	CreatePattern(L["^%a+ Artifact Relic$"],			                                SHINY_ARTIFACT_RELIC,  	       PATTERN_CATEGORY_LINE),
	CreatePattern(L["Item Level %d*"],			                                        SHINY_ITEMLEVEL,               PATTERN_CATEGORY_LINE),

	CreatePattern(L["{STAT_NUMBER} Item Levels"],			                            SHINY_ARTIFACT_RELIC_ITEMLEVEL,      PATTERN_CATEGORY_LINE),
	CreatePattern(L["{STAT_NUMBER} Rank:"],			                                    SHINY_ARTIFACT_RELIC_RANK,           PATTERN_CATEGORY_LINE),

	CreatePattern(L["%({STAT_NUMBER} damage per second%)"],			                    SHINY_WEAPONDPS,               PATTERN_CATEGORY_LINE),
	CreatePattern(L["{DAMAGE_RANGE} Damage"],			                                SHINY_WEAPONDAMAGE,            PATTERN_CATEGORY_LINE),
	CreatePattern(L["Speed {STAT_NUMBER}"],			                                    SHINY_WEAPONSPEED,             PATTERN_CATEGORY_LINE),



--[[  S  P  E  C  I  A  L  ]]--

	CreatePattern(L["^Binds when picked up"],			                                SHINY_PASSTHRU,                 PATTERN_CATEGORY_SPECIAL),
	CreatePattern(L["^Binds on equip"],			                                        SHINY_PASSTHRU,                 PATTERN_CATEGORY_SPECIAL),
	CreatePattern(L["^Soulbound"],			                                            SHINY_PASSTHRU,                 PATTERN_CATEGORY_SPECIAL),
	CreatePattern(L["^Unique"],			                                                SHINY_PASSTHRU,                 PATTERN_CATEGORY_SPECIAL),
	CreatePattern(L["^Unique-Equipped"],			                                    SHINY_PASSTHRU,                 PATTERN_CATEGORY_SPECIAL),
	CreatePattern(L["^Enchanted"],			                                            SHINY_PASSTHRU,                 PATTERN_CATEGORY_SPECIAL),
	CreatePattern(L["^Legacy Set"],			                                            SHINY_PASSTHRU,                 PATTERN_CATEGORY_SPECIAL),
	CreatePattern(L["^Chance on hit"],			                                        SHINY_PASSTHRU,                 PATTERN_CATEGORY_SPECIAL),
	CreatePattern(L["^Quest"],			                                                SHINY_PASSTHRU,                 PATTERN_CATEGORY_SPECIAL),
	CreatePattern(L["^Binds to Battle.net Account"],			                        SHINY_PASSTHRU,                 PATTERN_CATEGORY_SPECIAL),
	CreatePattern(L["%({STAT_NUMBER} %a+ Cooldown%)"],			                        SHINY_PASSTHRU,                 PATTERN_CATEGORY_SPECIAL),


--[[  R  E  S  I  S  T  A  N  C  E  S  ]]--

	CreatePattern(L["{STAT_NUMBER} Fire Resistance"],			                        SHINY_FIRERESISTANCE,           PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL),
	CreatePattern(L["{STAT_NUMBER} Frost Resistance"],			                        SHINY_FROSTRESISTANCE,          PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL),
	CreatePattern(L["{STAT_NUMBER} Nature Resistance"],			                        SHINY_NATURERESISTANCE,         PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL),
	CreatePattern(L["{STAT_NUMBER} Shadow Resistance"],			                        SHINY_SHADOWRESISTANCE,         PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL),
	CreatePattern(L["{STAT_NUMBER} Arcane Resistance"],			                        SHINY_ARCANERESISTANCE,         PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL),


--[[  D  A  M  A  G  E    S  C  H  O  O  L  S  ]]--

	CreatePattern(L["{STAT_NUMBER} Physical damage"],			                        SHINY_DAMAGE_PHYSICAL,	        PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	CreatePattern(L["{STAT_NUMBER} Holy damage"],			                            SHINY_DAMAGE_HOLY,	            PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	CreatePattern(L["{STAT_NUMBER} Fire damage"],			                            SHINY_DAMAGE_FIRE,	            PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	CreatePattern(L["{STAT_NUMBER} Frost damage"],			                            SHINY_DAMAGE_FROST,	            PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	CreatePattern(L["{STAT_NUMBER} Nature damage"],			                            SHINY_DAMAGE_NATURE,	        PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	CreatePattern(L["{STAT_NUMBER} Shadow damage"],			                            SHINY_DAMAGE_SHADOW,	        PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	CreatePattern(L["{STAT_NUMBER} Arcane damage"],			                            SHINY_DAMAGE_ARCANE,	        PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	
	CreatePattern(L["{STAT_NUMBER} as Physical damage"],					            SHINY_DAMAGE_PHYSICAL,	        PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	CreatePattern(L["{STAT_NUMBER} as Holy damage"],					                SHINY_DAMAGE_HOLY,	            PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	CreatePattern(L["{STAT_NUMBER} as Fire damage"],					                SHINY_DAMAGE_FIRE,	            PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	CreatePattern(L["{STAT_NUMBER} as Frost damage"],					                SHINY_DAMAGE_FROST,	            PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	CreatePattern(L["{STAT_NUMBER} as Nature damage"],					                SHINY_DAMAGE_NATURE,	        PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	CreatePattern(L["{STAT_NUMBER} as Shadow damage"],					                SHINY_DAMAGE_SHADOW,	        PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	CreatePattern(L["{STAT_NUMBER} as Arcane damage"],					                SHINY_DAMAGE_ARCANE,	        PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	
	CreatePattern(L["{STAT_NUMBER} as Physical"],			                            SHINY_DAMAGE_PHYSICAL,	        PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	CreatePattern(L["{STAT_NUMBER} as Holy"],			                                SHINY_DAMAGE_HOLY,	            PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	CreatePattern(L["{STAT_NUMBER} as Fire"],			                                SHINY_DAMAGE_FIRE,	            PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	CreatePattern(L["{STAT_NUMBER} as Frost"],			                                SHINY_DAMAGE_FROST,	            PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	CreatePattern(L["{STAT_NUMBER} as Nature"],			                                SHINY_DAMAGE_NATURE,	        PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	CreatePattern(L["{STAT_NUMBER} as Shadow"],			                                SHINY_DAMAGE_SHADOW,	        PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),
	CreatePattern(L["{STAT_NUMBER} as Arcane"],			                                SHINY_DAMAGE_ARCANE,	        PATTERN_CATEGORY_PARTIAL, PATTERN_CATEGORY_DAMAGE),



--[[  L  E  G  A  C  Y  ]]--

	CreatePattern(L["{STAT_NUMBER} [Pp]arry"],			                                    SHINY_PARRY,                    PATTERN_CATEGORY_LEGACY, PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL),
	CreatePattern(L["{STAT_NUMBER} [Dd]odge"],			                                    SHINY_DODGE,                    PATTERN_CATEGORY_LEGACY, PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL),
	CreatePattern(L["{STAT_NUMBER} [Aa]ttack [Pp]ower"],			  		                SHINY_ATTACKPOWER,              PATTERN_CATEGORY_LEGACY, PATTERN_CATEGORY_LINE, PATTERN_CATEGORY_PARTIAL),

	CreatePattern(L["[Pp]arry by {STAT_NUMBER}"],			                                SHINY_PARRY,                    PATTERN_CATEGORY_LEGACY, PATTERN_CATEGORY_PARTIAL),
	CreatePattern(L["[Dd]odge by {STAT_NUMBER}"],			                                SHINY_DODGE,                    PATTERN_CATEGORY_LEGACY, PATTERN_CATEGORY_PARTIAL),
	CreatePattern(L["[Aa]ttack [Pp]ower by {STAT_NUMBER}"],			                        SHINY_ATTACKPOWER,              PATTERN_CATEGORY_LEGACY, PATTERN_CATEGORY_PARTIAL),



--[[  E  Q  U  I  P:    P  R  O  C  ]]--

	CreatePattern(L["^Equip: Your damaging spells have a chance to (.+)"],		                    SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: Your damaging spells have a chance for (.+)"],		                    SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: Your damaging spellcasts have a chance to (.+)"],		                SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: Your damaging spells and abilities have a chance to (.+)"],		    SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: Your healing spells have a chance to (.+)"],		                    SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: Your healing spellcasts have a chance to (.+)"],		                SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: Your healing spells and abilities have a chance to (.+)"],		        SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: Your healing effects have a chance to (.+)"],		                    SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: When you heal you have a chance to (.+)"],		                        SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: Your spells and abilities have a chance to (.+)"],		                SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: Your spells have a chance to (.+)"],		           				    SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: When you deal damage or heal a target you have a chance to (.+)"],		SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: When you heal or deal damage you have a chance to (.+)"],		        SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: Your ranged attacks and spells have a chance to (.+)"],		        SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: Your ranged and melee attacks have a chance to (.+)"],					SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: Your ranged attacks have a chance to (.+)"],		                    SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: Your melee attacks have a chance to (.+)"],		                    SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: Your critical autoattacks have a chance to (.+)"],		                SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: When your attacks hit you have a chance to (.+)"],		                SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: Your attacks have a chance to (.+)"],		                            SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: When you deal damage you have a chance to (.+)"],		                SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: Taking damage has a chance to (.+)"],		                            SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),
	CreatePattern(L["^Equip: Chance on being hit to (.+)"],		                                    SHINY_EQUIP_PROC,	PATTERN_CATEGORY_EQUIP_PROC),



--[[  E  Q  U  I  P:    E  F  F  E  C  T  ]]--

	CreatePattern(L["^Equip: Your melee auto attacks (.+)"],		                                    SHINY_EQUIP_EFFECT,	PATTERN_CATEGORY_EQUIP_EFFECT),



--[[  M  U  L  T  I  P  L  E  ]]--
	CreatePattern(L["Agility"],		                                  								SHINY_AGILITY,	  PATTERN_CATEGORY_PARTIAL_JOIN),
	CreatePattern(L["Intellect"],		                                  							SHINY_INTELLECT,  PATTERN_CATEGORY_PARTIAL_JOIN),
	CreatePattern(L["Stamina"],		                                  								SHINY_STAMINA,	  PATTERN_CATEGORY_PARTIAL_JOIN),
	CreatePattern(L["Strength"],		                                  							SHINY_STRENGTH,	  PATTERN_CATEGORY_PARTIAL_JOIN),
	CreatePattern(L["[Cc]ritical [Ss]trike"],		                                  				SHINY_CRITICAL,	  PATTERN_CATEGORY_PARTIAL_JOIN),
	CreatePattern(L["[Hh]aste"],		                                			  				SHINY_HASTE,	  PATTERN_CATEGORY_PARTIAL_JOIN),
	CreatePattern(L["[Mm]astery"],		                                			  				SHINY_MASTERY,	  PATTERN_CATEGORY_PARTIAL_JOIN),
}
